
//		HtmlEntities.cpp -- All HTML 4 character entities.


#ifndef HTML_ENTITIES_VERSION


#define HTML_ENTITIES_VERSION		1.0.3.0
#define NUM_HTML_ENTITIES			257
#define NUM_MANDATORY_ENTITIES		5
#define ENTITY_MAX_NAME_LEN			9

#define HTML_ENTITIES_MIN_BUFFER	128


#ifndef UNICODE_MAX_CHAR

#define UNICODE_MAX_CHAR			0x10ffff
#define SURROGATE_SIG_MASK			0xfc00
#define SURROGATE_SIG_HIGH			0xd800
#define SURROGATE_SIG_LOW			0xdc00
#define SURROGATE_MASK				0x03ff
#define SURROGATE_OFFSET			0x10000

#endif	//	UNICODE_MAX_CHAR



struct _HtmlEntity
{
	wchar_t Char;
	wchar_t Name[ENTITY_MAX_NAME_LEN];
};


_HtmlEntity HtmlEntity[NUM_HTML_ENTITIES] = {

	//	'Mandatory' characters; these will always be entitized :

	{ 0x0022, L"quot" }, 
	{ 0x0026, L"amp" }, 
	{ 0x003c, L"lt" }, 
	{ 0x003e, L"gt" }, 
	{ 0x00a0, L"nbsp" }, 

	//	Latin-1 :

	{ 0x0027, L"apos" }, 
	{ 0x007c, L"vert" }, 
	{ 0x00a1, L"iexcl" }, 
	{ 0x00a2, L"cent" }, 
	{ 0x00a3, L"pound" }, 
	{ 0x00a4, L"curren" }, 
	{ 0x00a5, L"yen" }, 
	{ 0x00a6, L"brvbar" }, 
	{ 0x00a7, L"sect" }, 
	{ 0x00a8, L"uml" }, 
	{ 0x00a9, L"copy" }, 
	{ 0x00aa, L"ordf" }, 
	{ 0x00ab, L"laquo" }, 
	{ 0x00ac, L"not" }, 
	{ 0x00ad, L"shy" }, 
	{ 0x00ae, L"reg" }, 
	{ 0x00af, L"macr" }, 
	{ 0x00b0, L"deg" }, 
	{ 0x00b1, L"plusmn" }, 
	{ 0x00b2, L"sup2" }, 
	{ 0x00b3, L"sup3" }, 
	{ 0x00b4, L"acute" }, 
	{ 0x00b5, L"micro" }, 
	{ 0x00b6, L"para" }, 
	{ 0x00b7, L"middot" }, 
	{ 0x00b8, L"cedil" }, 
	{ 0x00b9, L"sup1" }, 
	{ 0x00ba, L"ordm" }, 
	{ 0x00bb, L"raquo" }, 
	{ 0x00bc, L"frac14" }, 
	{ 0x00bd, L"frac12" }, 
	{ 0x00bd, L"half" }, 
	{ 0x00be, L"frac34" }, 
	{ 0x00bf, L"iquest" }, 
	{ 0x00c0, L"Agrave" }, 
	{ 0x00c1, L"Aacute" }, 
	{ 0x00c2, L"Acirc" }, 
	{ 0x00c3, L"Atilde" }, 
	{ 0x00c4, L"Auml" }, 
	{ 0x00c5, L"Aring" }, 
	{ 0x00c6, L"AElig" }, 
	{ 0x00c7, L"Ccedil" }, 
	{ 0x00c8, L"Egrave" }, 
	{ 0x00c9, L"Eacute" }, 
	{ 0x00ca, L"Ecirc" }, 
	{ 0x00cb, L"Euml" }, 
	{ 0x00cc, L"Igrave" }, 
	{ 0x00cd, L"Iacute" }, 
	{ 0x00ce, L"Icirc" }, 
	{ 0x00cf, L"Iuml" }, 
	{ 0x00d0, L"ETH" }, 
	{ 0x00d1, L"Ntilde" }, 
	{ 0x00d2, L"Ograve" }, 
	{ 0x00d3, L"Oacute" }, 
	{ 0x00d4, L"Ocirc" }, 
	{ 0x00d5, L"Otilde" }, 
	{ 0x00d6, L"Ouml" }, 
	{ 0x00d7, L"times" }, 
	{ 0x00d8, L"Oslash" }, 
	{ 0x00d9, L"Ugrave" }, 
	{ 0x00da, L"Uacute" }, 
	{ 0x00db, L"Ucirc" }, 
	{ 0x00dc, L"Uuml" }, 
	{ 0x00dd, L"Yacute" }, 
	{ 0x00de, L"THORN" }, 
	{ 0x00df, L"szlig" }, 
	{ 0x00e0, L"agrave" }, 
	{ 0x00e1, L"aacute" }, 
	{ 0x00e2, L"acirc" }, 
	{ 0x00e3, L"atilde" }, 
	{ 0x00e4, L"auml" }, 
	{ 0x00e5, L"aring" }, 
	{ 0x00e6, L"aelig" }, 
	{ 0x00e7, L"ccedil" }, 
	{ 0x00e8, L"egrave" }, 
	{ 0x00e9, L"eacute" }, 
	{ 0x00ea, L"ecirc" }, 
	{ 0x00eb, L"euml" }, 
	{ 0x00ec, L"igrave" }, 
	{ 0x00ed, L"iacute" }, 
	{ 0x00ee, L"icirc" }, 
	{ 0x00ef, L"iuml" }, 
	{ 0x00f0, L"eth" }, 
	{ 0x00f1, L"ntilde" }, 
	{ 0x00f2, L"ograve" }, 
	{ 0x00f3, L"oacute" }, 
	{ 0x00f4, L"ocirc" }, 
	{ 0x00f5, L"otilde" }, 
	{ 0x00f6, L"ouml" }, 
	{ 0x00f7, L"divide" }, 
	{ 0x00f8, L"oslash" }, 
	{ 0x00f9, L"ugrave" }, 
	{ 0x00fa, L"uacute" }, 
	{ 0x00fb, L"ucirc" }, 
	{ 0x00fc, L"uuml" }, 
	{ 0x00fd, L"yacute" }, 
	{ 0x00fe, L"thorn" }, 
	{ 0x00ff, L"yuml" }, 
	{ 0x0152, L"OElig" }, 
	{ 0x0153, L"oelig" }, 
	{ 0x0160, L"Scaron" }, 
	{ 0x0161, L"scaron" }, 
	{ 0x0178, L"Yuml" }, 
	{ 0x017d, L"Zcaron" }, 
	{ 0x017e, L"zcaron" }, 
	{ 0x0192, L"fnof" }, 
	{ 0x02c6, L"circ" }, 
	{ 0x02dc, L"tilde" }, 

	//	Greek alphabet :

	{ 0x0391, L"Alpha" }, 
	{ 0x0392, L"Beta" }, 
	{ 0x0393, L"Gamma" }, 
	{ 0x0394, L"Delta" }, 
	{ 0x0395, L"Epsilon" }, 
	{ 0x0396, L"Zeta" }, 
	{ 0x0397, L"Eta" }, 
	{ 0x0398, L"Theta" }, 
	{ 0x0399, L"Iota" }, 
	{ 0x039a, L"Kappa" }, 
	{ 0x039b, L"Lambda" }, 
	{ 0x039c, L"Mu" }, 
	{ 0x039d, L"Nu" }, 
	{ 0x039e, L"Xi" }, 
	{ 0x039f, L"Omicron" }, 
	{ 0x03a0, L"Pi" }, 
	{ 0x03a1, L"Rho" }, 
	{ 0x03a3, L"Sigma" }, 
	{ 0x03a4, L"Tau" }, 
	{ 0x03a5, L"Upsilon" }, 
	{ 0x03a6, L"Phi" }, 
	{ 0x03a7, L"Chi" }, 
	{ 0x03a8, L"Psi" }, 
	{ 0x03a9, L"Omega" }, 
	{ 0x03b1, L"alpha" }, 
	{ 0x03b2, L"beta" }, 
	{ 0x03b3, L"gamma" }, 
	{ 0x03b4, L"delta" }, 
	{ 0x03b5, L"epsilon" }, 
	{ 0x03b6, L"zeta" }, 
	{ 0x03b7, L"eta" }, 
	{ 0x03b8, L"theta" }, 
	{ 0x03b9, L"iota" }, 
	{ 0x03ba, L"kappa" }, 
	{ 0x03bb, L"lambda" }, 
	{ 0x03bc, L"mu" }, 
	{ 0x03bd, L"nu" }, 
	{ 0x03be, L"xi" }, 
	{ 0x03bf, L"omicron" }, 
	{ 0x03c0, L"pi" }, 
	{ 0x03c1, L"rho" }, 
	{ 0x03c2, L"sigmaf" }, 
	{ 0x03c3, L"sigma" }, 
	{ 0x03c4, L"tau" }, 
	{ 0x03c5, L"upsilon" }, 
	{ 0x03c6, L"phi" }, 
	{ 0x03c7, L"chi" }, 
	{ 0x03c8, L"psi" }, 
	{ 0x03c9, L"omega" }, 
	{ 0x03d1, L"thetasym" }, 
	{ 0x03d2, L"upsih" }, 
	{ 0x03d6, L"piv" }, 

	//	Punctuation and spaces :

	{ 0x2002, L"ensp" }, 
	{ 0x2003, L"emsp" }, 
	{ 0x2009, L"thinsp" }, 
	{ 0x200c, L"zwnj" }, 
	{ 0x200d, L"zwj" }, 
	{ 0x200e, L"lrm" }, 
	{ 0x200f, L"rlm" }, 
	{ 0x2013, L"ndash" }, 
	{ 0x2014, L"mdash" }, 
	{ 0x2018, L"lsquo" }, 
	{ 0x2019, L"rsquo" }, 
	{ 0x201a, L"sbquo" }, 
	{ 0x201c, L"ldquo" }, 
	{ 0x201d, L"rdquo" }, 
	{ 0x201e, L"bdquo" }, 
	{ 0x2020, L"dagger" }, 
	{ 0x2021, L"Dagger" }, 
	{ 0x2022, L"bull" }, 
	{ 0x2026, L"hellip" }, 
	{ 0x2030, L"permil" }, 
	{ 0x2032, L"prime" }, 
	{ 0x2033, L"Prime" }, 
	{ 0x2039, L"lsaquo" }, 
	{ 0x203a, L"rsaquo" }, 
	{ 0x203e, L"oline" }, 
	{ 0x2044, L"frasl" }, 

	//	Arrows and miscellaneous symbols :

	{ 0x20ac, L"euro" }, 
	{ 0x2111, L"image" }, 
	{ 0x2118, L"weierp" }, 
	{ 0x211c, L"real" }, 
	{ 0x2122, L"trade" }, 
	{ 0x2135, L"alefsym" }, 
	{ 0x2190, L"larr" }, 
	{ 0x2191, L"uarr" }, 
	{ 0x2192, L"rarr" }, 
	{ 0x2193, L"darr" }, 
	{ 0x2194, L"harr" }, 
	{ 0x21b5, L"crarr" }, 
	{ 0x21d0, L"lArr" }, 
	{ 0x21d1, L"uArr" }, 
	{ 0x21d2, L"rArr" }, 
	{ 0x21d3, L"dArr" }, 
	{ 0x21d4, L"hArr" }, 

	//	Mathematical symbols :

	{ 0x2200, L"forall" }, 
	{ 0x2202, L"part" }, 
	{ 0x2203, L"exist" }, 
	{ 0x2205, L"empty" }, 
	{ 0x2207, L"nabla" }, 
	{ 0x2208, L"isin" }, 
	{ 0x2209, L"notin" }, 
	{ 0x220b, L"ni" }, 
	{ 0x220f, L"prod" }, 
	{ 0x2211, L"sum" }, 
	{ 0x2212, L"minus" }, 
	{ 0x2217, L"lowast" }, 
	{ 0x221a, L"radic" }, 
	{ 0x221d, L"prop" }, 
	{ 0x221e, L"infin" }, 
	{ 0x2220, L"ang" }, 
	{ 0x2227, L"and" }, 
	{ 0x2228, L"or" }, 
	{ 0x2229, L"cap" }, 
	{ 0x222a, L"cup" }, 
	{ 0x222b, L"int" }, 
	{ 0x2234, L"there4" }, 
	{ 0x223c, L"sim" }, 
	{ 0x2245, L"cong" }, 
	{ 0x2248, L"asymp" }, 
	{ 0x2260, L"ne" }, 
	{ 0x2261, L"equiv" }, 
	{ 0x2264, L"le" }, 
	{ 0x2265, L"ge" }, 
	{ 0x2282, L"sub" }, 
	{ 0x2283, L"sup" }, 
	{ 0x2284, L"nsub" }, 
	{ 0x2286, L"sube" }, 
	{ 0x2287, L"supe" }, 
	{ 0x2295, L"oplus" }, 
	{ 0x2297, L"otimes" }, 
	{ 0x22a5, L"perp" }, 
	{ 0x22c5, L"sdot" }, 
	{ 0x2308, L"lceil" }, 
	{ 0x2309, L"rceil" }, 
	{ 0x230a, L"lfloor" }, 
	{ 0x230b, L"rfloor" }, 
	{ 0x2329, L"lang" }, 
	{ 0x232a, L"rang" }, 
	{ 0x25ca, L"loz" }, 
	{ 0x2660, L"spades" }, 
	{ 0x2663, L"clubs" }, 
	{ 0x2665, L"hearts" }, 
	{ 0x2666, L"diams" }, 
};


wchar_t Windows1252[32]		= { 0x20ac, 0x0081, 0x201a, 0x0192, 0x201e, 0x2026, 0x2020, 0x2021,
								0x02c6, 0x2030, 0x0160, 0x2039, 0x0152, 0x008d, 0x017d, 0x008f,
								0x0090, 0x2018, 0x2019, 0x201c, 0x201d, 0x2022, 0x2013, 0x2014,
								0x02dc, 0x2122, 0x0161, 0x203a, 0x0153, 0x009d, 0x017e, 0x0178 };



LPCTSTR MandatoryEntityName( wchar_t ch )
{
	for ( unsigned int i = 0; i < NUM_MANDATORY_ENTITIES; i++ )
		if ( ch == HtmlEntity[i].Char )
			return HtmlEntity[i].Name;

	return NULL;
}



int Entitize( LPTSTR String, size_t buflen )
{
	if ( !String || ( buflen < HTML_ENTITIES_MIN_BUFFER ) )
		return -1;


	wchar_t *temp					= NULL;
	wchar_t tmp2[16]				= L"";
	LPCTSTR Entity					= NULL;
	unsigned int HighChar			= 0;
	size_t j						= 0;
	int k							= 0;
	wchar_t rchar					= '\0';


	temp = (wchar_t*) malloc( buflen * sizeof( wchar_t ) );
	if ( !temp )
		return -3;

	temp[0] = '\0';


	for ( size_t i = 0; String[i]; i++ ) {

		if ( Entity = MandatoryEntityName( String[i] ) ) {

			if ( ( j + wcslen( Entity ) + 2 ) >= buflen )
				goto Overflow;

			temp[j++] = '&';
			temp[j]   = '\0';
			wcscat_s( temp, buflen, Entity );
			wcscat_s( temp, buflen, L";" );
			j = wcslen( temp );
			k++;

		}
		else if ( ( String[i] >= 0x0080 ) && ( String[i] <= 0x009f ) ) {

			rchar = Windows1252[String[i] & 0x001f ];
			wsprintf( tmp2, L"&#x%x;", rchar );

			if ( ( j + wcslen( tmp2 ) ) >= buflen )
				goto Overflow;

			wcscat_s( temp, buflen, tmp2 );
			j = wcslen( temp );
			k++;
		}
		else if ( iswcntrl( String[i] ) ) {

			wsprintf( tmp2, L"&#%u;", String[i] );

			if ( ( j + wcslen( tmp2 ) ) >= buflen )
				goto Overflow;

			wsprintf( temp + j, L"&#%u;", String[i] );
			j = wcslen( temp );
			k++;
		}
		else if ( ( ( String[i] & SURROGATE_SIG_MASK ) == SURROGATE_SIG_HIGH ) && ( ( String[i + 1] & SURROGATE_SIG_MASK ) == SURROGATE_SIG_LOW ) ) {

			HighChar = ( ( ( String[i] & SURROGATE_MASK ) << 10 ) | ( String[i + 1] & SURROGATE_MASK ) ) + SURROGATE_OFFSET;
			wsprintf( tmp2, L"&#x%x;", HighChar );

			if ( ( j + wcslen( tmp2 ) ) >= buflen )
				goto Overflow;

			wcscat_s( temp, buflen, tmp2 );
			j = wcslen( temp );
			i++;
			k++;
		}
		else {
			if ( j < ( buflen - 1 ) ) {
				temp[j++] = String[i];
				temp[j] = '\0';
			}
			else
				goto Overflow;
		}
	}

	wcscpy_s( String, buflen, temp );
	free( temp );
	return k;


Overflow:

	free( temp );
	return -2;
}



unsigned int ParseEntity( LPTSTR String, size_t *EntityLen )
{
	if ( !String )
		return 0;


	wchar_t temp[SHORT_BUF_LEN]			= L"";
	wchar_t ch							= '\0';
	size_t j							= 0;
	unsigned int value					= 0;
	wchar_t *sep1						= NULL;


	if ( EntityLen )
		*EntityLen = 0;

	if ( String[0] != '&' )
		return 0;


	for ( size_t i = 1; String[i]; i++ ) {
		ch = String[i];

		if ( ( ch == '\0' ) || ( ch > 0x7f ) )
			return 0;
		else if ( ch == ';' ) {

			if ( !j )
				return 0;

			if ( ( temp[0] == '#' ) && iswdigit( temp[1] ) ) {
				_set_errno( 0 );

				value = wcstoul( temp + 1, &sep1, 10 );

				if ( errno || *sep1 )
					return 0;

				if ( !value || ( value > UNICODE_MAX_CHAR ) )
					return 0;

				if ( ( value >= 0x0080 ) && ( value <= 0x009f ) )
					value = Windows1252[value & 0x001f];

				if ( EntityLen )
					*EntityLen = wcslen( temp ) + 2;

				return value;
			}
			else if ( ( temp[0] == '#' ) && ( towlower( temp[1] ) == 'x' ) && iswxdigit( temp[2] ) ) {
				_set_errno( 0 );

				value = wcstoul( temp + 2, &sep1, 16 );

				if ( errno || *sep1 )
					return 0;

				if ( !value || ( value > UNICODE_MAX_CHAR ) )
					return 0;

				if ( ( value >= 0x0080 ) && ( value <= 0x009f ) )
					value = Windows1252[value & 0x001f];

				if ( EntityLen )
					*EntityLen = wcslen( temp ) + 2;

				return value;
			}

			for ( int i = 0; i < NUM_HTML_ENTITIES; i++ ) {
				if ( !wcscmp( HtmlEntity[i].Name, temp ) ) {
					if ( EntityLen )
						*EntityLen = wcslen( temp ) + 2;

					return HtmlEntity[i].Char;
				}
			}

			for ( int i = 0; i < NUM_MANDATORY_ENTITIES; i++ ) {
				if ( !_wcsicmp( HtmlEntity[i].Name, temp ) ) {
					if ( EntityLen )
						*EntityLen = wcslen( temp ) + 2;

					return HtmlEntity[i].Char;
				}
			}

			return 0;
		}
		else {
			if ( j >= ( SHORT_BUF_LEN - 1 ) )
				return 0;

			temp[j++] = ch;
			temp[j]   = '\0';
		}
	}

	return 0;
}



int Deentitize( LPTSTR String, size_t buflen )
{
	if ( !String || ( buflen < HTML_ENTITIES_MIN_BUFFER ) )
		return -1;


	wchar_t *temp						= NULL;
	size_t j							= 0;
	int k								= 0;
	unsigned int EntityChar				= 0;
	size_t EntityLen					= 0;


	temp = (wchar_t*) malloc( buflen * sizeof( wchar_t ) );
	if ( !temp )
		return -3;

	temp[0] = '\0';


	for ( size_t i = 0; String[i]; i++ ) {

		if ( String[i] == '&' ) {

			EntityChar = ParseEntity( String + i, &EntityLen );

			if ( EntityChar ) {
				if ( EntityChar <= 0xffff ) {
					if ( j >= ( buflen - 1 ) )
						goto Overflow;

					temp[j++]	= EntityChar;
					temp[j]		= '\0';
				}
				else {
					if ( j >= ( buflen - 2 ) )
						goto Overflow;

					EntityChar -= SURROGATE_OFFSET;
					temp[j++]	= ( EntityChar >> 10 ) | SURROGATE_SIG_HIGH;
					temp[j++]	= ( EntityChar & SURROGATE_MASK ) | SURROGATE_SIG_LOW;
					temp[j]		= '\0';
				}

				k++;
				i += EntityLen - 1;
			}
			else {
				if ( j >= ( buflen - 1 ) )
					goto Overflow;

				temp[j++]	= '&';
				temp[j]		= '\0';
			}
		}
		else {

			if ( j >= ( buflen - 1 ) )
				goto Overflow;

			temp[j++]	= String[i];
			temp[j]		= '\0';
		}
	}

	wcscpy_s( String, buflen, temp );
	free( temp );
	return k;


Overflow:

	free( temp );
	return -2;
}


#endif	//	HTML_ENTITIES_VERSION


/*

	1.0.0.0		2022-03-24
				Supports all HTML 4 character entities, high-order Unicode
				characters, and remap of C1 control characters to Windows-1252
				characters.

	1.0.1.0		2022-03-29
				Allows for different, caller-specified buffer sizes.

	1.0.2.0		2022-06-17
				Makes the *EntityLen parameter to ParseEntity() optional.

	1.0.3.0		2023-07-28
				Removed &vert; from the list of mandatory entities.  (It's
				not actually an HTML 4 entity anyway.)

*/
